#ifndef __MAIN_H__
#define __MAIN_H__

#define SPRITE_SIZE 40 //29*11/8 pixels
#define SPRITE_WIDTH 29
#define SPRITE_HEIGHT 11

#define START_POS 20

const short KEY_RIGHT = 0x0107;
const short KEY_UP    = 0x0108;
const short KEY_EXE   = 0x0201;
const short KEY_DOWN  = 0x0207;
const short KEY_LEFT  = 0x0208;
const short KEY_MENU  = 0x0308;
const short KEY_F3    = 0x0409;
const short KEY_TWO   = 0x0502;
const short KEY_ONE   = 0x0602;
const short KEY_ALPHA = 0x0607;
const short KEY_SHIFT = 0x0608;

typedef struct {
	double posX;
	double posY;
	double speed;
	double pushForce;
} Player;

typedef enum {
	BACKWARDS = -1, LEFT, FORWARDS, RIGHT
} Direction;

//Booster, no zone, slowing zone, blocking zone, bullshit zone (is put with the good zones to trick the AI into moving to the boosters)
typedef enum {
	BST = -1, NZ, SZ, BZ, BSZ
} Zone;

typedef enum {
	RUNNING, FINISHED, PLAYER_DEAD
} GameState;

typedef enum {
	NOT_PRESSED, PRESSED, STILL_PRESSED
} ShiftState;

typedef enum {
	NEW_LVL, RESTART_LVL
} LevelState;

void dispSprite(unsigned char *bitmap, int x, int y);
void exit();
void map1();
void ai(Player *bot);
void setMap(int map);
void go(Direction direction, Player *player);
int checkZone(int x, int y, Player *player_);
void gameOver();
void dispMap();
int gameFinished();
void push(Direction direction, Player *player);
void dialogMenu(char* str);
void setLvl(int lvl, LevelState lvlState);
void play();
void dispCountdown();
void dispMenu();

#endif